function [Ig,CG] = MMI(pos)
% This function determines the mass moment of inertia matrix for a system
% distributed with points.

Mf = pos.foil.mass;
Mh = pos.hull.mass;
Ms = pos.sail.mass;
M = [Mf; Mh; Ms];

X = [pos.foil.cord(:,1); pos.sail.cord(:,1); pos.hull.cord(:,1)];
Y = [pos.foil.cord(:,2); pos.sail.cord(:,2); pos.hull.cord(:,2)];
Z = [pos.foil.cord(:,3); pos.sail.cord(:,3); pos.hull.cord(:,3)];

mt = sum(M); 

Xcg =(1/mt)*sum(M.*X); 
Ycg =(1/mt)*sum(M.*Y);
Zcg =(1/mt)*sum(M.*Z);

CG = [Xcg; Ycg; Zcg];
Ig = [0 0 0; 0 0 0; 0 0 0];

[a,b] = size(M);
for i =1:a
    x = (X(i) - Xcg);
    y = (Y(i) - Ycg);
    z = (Z(i) - Zcg);
    m = M(i);
 Ig = Ig + [  m*(y^2 + z^2),    -m*x*y,         -m*x*z;
             -m*y*x,             m*(x^2 + z^2), -m*y*z;
             -m*x*z,            -m*y*z,          m*(y^2 + x^2)];
end

end