function res = UVLM(Vel,domain,res)
tic
m = domain.mm;
n = domain.nn;
d = 0;
nn = cell2mat(domain.N');
nn = nn(:);
nn = reshape(nn,3,[])';
dy = abs(diff(abs(domain.test2.y(1,:))));
dy = repmat(dy,n,1);
dx = abs(diff(abs(domain.test2.x(:,1))));
dx = repmat(dx,1,m);

% Creating incoming velocity vector for 
Vx = Vel(1).*linspace(0,1,n).^2;
    Vy = Vel(2).*linspace(0,1,n).^2;
    Vz = Vel(3).*linspace(0,1,n).^2;
    Vair = [Vx; -Vy; Vz]';
% Changing which direction the spanlength is determined
if domain.ang.phi == 90
    asd = 1;
    dy = abs(diff(abs(domain.test2.z(1,:))));
    dy = repmat(dy,n,1);
end

if domain.ang.the == 180
    
   Vel(3) = -Vel(3); 
end

V2 = Vel;


for kk = 1:n
    for jj = 1:m
        
    d = d+1;
    cp = cell2mat(domain.CP(kk,jj));
    % Induced Velocity from the body onto the body
    vel = inducedfast(cp,domain);
    % Induced Velocity from the wake onto the body
    vel2 = inducedfastwake(cp,domain);
    % Induced Downwash from the body onto the body
    vel3 = inducedfastdrag(cp,domain);
    % Induced Downwash from the wake onto the body
    vel4 = inducedfastdragwake(cp,domain);
   
    vel(end-m+1:end,:) = vel(end-m+1:end,:)+vel2;
    
    vel3(end-m+1:end,:) = vel3(end-m+1:end,:)+vel4;
    % Was unable to simulate the free surface as geometry definition was
    % not optimal. i.e foil was sticking above z = 0, even though it
    % shouldn't
%     if domain.case == 1
% % Determining effect of free surface
%     velim = inducedmirror(cp,domain);
%     velim(:,3) = -velim(:,3);
%     vel = vel+velim;
    
%     end    
    % Establishing influence matrix and downwash influence matrix
LHSa = vel*nn(d,:)';

LHSb = vel3*nn(d,:)';
    % Perturbation potential
    Vw = inducedvel3(cp,domain,res);
    % Perturbation Potential + Inflow Potential
    V = V2'-Vw;
    % Neumann Dirichlett Boundary Condition V phi * n = 0
    if domain.case == 0
        % Used if sail
        RHS(d) = -Vair(kk,:)*nn(d,:)';    
        
    else
        % Used if hydrofoil
        RHS(d) = -V*nn(d,:)';
    
    end

    if d == 1
       Vt = V;
       a = LHSa';
       b = LHSb';
    else
        Vt = [Vt; V];
        a = [a; LHSa'];
        b = [b; LHSb'];
    end
    end
end
% Solving the boundary condition for circulation
circulation = a\RHS';
drag = b*circulation;
circulation = reshape(circulation,m,[])';
drag = reshape(drag,m,[])';
    
    if res.k < 2
    changecirc = zeros(kk,jj);
    else
        oldcirc = res.circ;
        changecirc = (circulation-oldcirc)./domain.dt;
    end
    
    d = 0;
    circulation = circulation';
    dx = dx';
    dy = dy';
    changecirc = changecirc';
    [kk, jj] = size(circulation);
    dp = zeros(kk,jj);
    % Determining the pressure on each element
for j = 1:n
    
    for i = 1:m
    
    d = d+1;
    np = null(nn(d,:));
    npy = np(:,1); npx = np(:,2);
        if i == 1 && j > 1
    dp(i,j) =  domain.rho*(((Vt(d,:)*npx*circulation(i,j))/dx(i,j))...
            +(Vt(d,:)*npy*(circulation(i,j)-circulation(i,j-1))/dy(i,j))+changecirc(i,j));
      
        elseif j == 1 && i > 1
    dp(i,j) =  domain.rho*((Vt(d,:)*npx*(circulation(i,j)-circulation(i-1,j))/dx(i,j))...
        +(Vt(d,:)*npy*(circulation(i,j))/dy(i,j))+changecirc(i,j));
        elseif i == 1 && j == 1
    dp(i,j) =  domain.rho*(((Vt(d,:)*npx*circulation(i,j))/dx(i,j))...
        +(Vt(d,:)*npy*(circulation(i,j))/dy(i,j))+changecirc(i,j));
        else
    dp(i,j) =  domain.rho*((Vt(d,:)*npx*(circulation(i,j)-circulation(i-1,j))/dx(i,j))...
            +(Vt(d,:)*npy*(circulation(i,j)-circulation(i,j-1))/dy(i,j))+changecirc(i,j));
        
        end
        
        if i > m/2
            
            if i == m && j < n
    dp(i,j) =  domain.rho*(((Vt(d,:)*npx*circulation(i,j))/dx(i,j))...
            +(Vt(d,:)*npy*(circulation(i,j)-circulation(i,j+1))/dy(i,j))+changecirc(i,j));
      
        elseif j == n && i < m
    dp(i,j) =  domain.rho*((Vt(d,:)*npx*(circulation(i,j)-circulation(i+1,j))/dx(i,j))...
        +(Vt(d,:)*npy*(circulation(i,j))/dy(i,j))+changecirc(i,j));
        elseif i == m && j == n
    dp(i,j) =  domain.rho*(((Vt(d,:)*npx*circulation(i,j))/dx(i,j))...
        +(Vt(d,:)*npy*(circulation(i,j))/dy(i,j))+changecirc(i,j));
        else
    dp(i,j) =  domain.rho*((Vt(d,:)*npx*(circulation(i,j)-circulation(i+1,j))/dx(i,j))...
            +(Vt(d,:)*npy*(circulation(i,j)-circulation(i,j+1))/dy(i,j))+changecirc(i,j));
        
            end
            
        end
       
    end
end

S = domain.S.';
S = S(:);
res.dP = dp;
dp = dp(:);
dF = -S.*dp.*nn;
F = sum(dF);

res.Ly = F(2);
res.Lz = F(3);
if domain.ang.the == 180
    
 res.Ly = -F(2);
end

res.D = F(1);
res.t = toc;
res.RHS = RHS;
res.circ = circulation;
res.LHSa = a;
res.LHSb = b;
res.k = res.k + 1;

end