function [wind] = VelocityTriangle(Vel,wind,B)

% This function determines the true wind speed and angle.

  Vs = sqrt(Vel(1)^2+Vel(2)^2+Vel(3)^2);
  Vt = wind.Vt;
   wind_angle = wind.angle;
   Va    =   sqrt(Vt^2 + Vs^2 -2*Vt*Vs*cosd(wind_angle));
   beta    = acosd((Vs^2+Va^2 - Vt^2)/(2*Vs*Va));
  
    W = [-Va*cosd(beta); -Va*sind(beta); 0];
    
    Wphi = B*W;
    
   wind.Va = sqrt(Wphi(1)^2+Wphi(2)^2+Wphi(3)^2);
    
    wind.beta = atand(Wphi(2)/Wphi(1));
    
end