function Ma = addedmass(hydro)

% This function determines the total added mass of the hydrofoil system.

[dd,ff] = size(hydro);

for j = 1:ff

    domain = hydro.domain(j);
    span = domain.span;
    chord = domain.chord;
    rho = domain.rho;
    
m11(j) = span*rho*pi*chord^2;
m22(j) = chord*rho*pi*span^2;
m55(j) = rho*(span^2-chord^2);

end

Ma = [  sum(m11) 0 0 0 0 0;...
        0 sum(m22) 0 0 0 0;...
        0 0 sum(m22) 0 0 0;...
        0 0 0 0 0 0;...
        0 0 0 0 sum(m55) 0;...
        0 0 0 0 0 sum(m55);];



end