function [equil,hull] = equi(Force,amr,hull,Para)
% This function determines the total force and torque of the vessel.

armfoil = amr.f;
armsail = amr.sail;
armhull = amr.hull;

Ff = Force.Ff;
Fs = Force.Fs;
Fv = Force.Fv;
% Determining torque components
torque = [Ff(3,:).*armfoil(2,:) Fs(3)*armsail(2) Fv(3).*armhull(2);... 
          Ff(2,:).*armfoil(3,:) Fs(2)*armsail(3) Fv(2).*armhull(2);...
          -Ff(1,:).*armfoil(3,:) Fs(1)*armsail(3) Fv(1).*armhull(3);...
          -Ff(3,:).*armfoil(1,:) Fs(3)*armsail(1) Fv(3).*armhull(1);...
          -Ff(2,:).*armfoil(1,:) Fs(2)*armsail(2) Fv(2).*armhull(2);...
          Ff(1,:).*armfoil(2,:) Fs(1)*armsail(2) Fv(1).*armhull(1);];      
% notice My, pitch has an hadded torque due to the crew.
equil.Mx = sum(torque(1,:))+sum(torque(2,:));
equil.My = sum(torque(3,:))+sum(torque(4,:))-Force.Fv(3,2)*hull.char(1)/4; 
equil.Mz = sum(torque(5,:))+sum(torque(6,:));   
equil.Fx = sum(Force.Ff(1,:))+Force.Fs(1)+sum(Force.Fv(1,:));
equil.Fy = sum(Force.Ff(2,:))+Force.Fs(2)+sum(Force.Fv(2,:));
equil.Fz = sum(Force.Ff(3,:))+Force.Fs(3)+sum(Force.Fv(3,:));

% Finding optimum position of the additional crew member.
A = equil.Mx;
B = equil.My;
armx = (0:-0.01:-hull.char(1)/2);
army = (0:-0.01:-(hull.char(2)+hull.char(3))/2);

if Para.phi > 0
newx = A-Force.Fv(3,2)*army/2;
[a,b] = min(abs(newx));
equil.Mx = equil.Mx-Force.Fv(3,2)*army(b)/2;
else
   b = 1; 
end

newx = B-Force.Fv(3,2)*armx/2;

[d,f] = min(abs(newx));
equil.torque = torque;
equil.My = equil.My-Force.Fv(3,2)*armx(f)/2;
hull.crewpos = [army(b); armx(f)];
end