function [domain] = geomdisc(domain)

xg = domain.CG(1);
yg = domain.CG(2);
zg = domain.CG(3);

span = domain.span;
chord = domain.chord;
NACA = domain.NACA;
n = domain.n;
m = domain.m;
domain.nn = n;
domain.mm = m;
domain.vel = domain.vel;
[XP,ZP,~] = foilpoints(NACA,n+1);
ZP = ZP.*chord;
if domain.ang.phi > 90
    ZP = -ZP;
end
domain.case = 1;
% cosine distribution of elements
for k = 1:m+1
    
    test(k) = span*(1-cos(k*pi/(m+2)))/2;

end

for k = 1:n+1

    test2(k) = chord*(1-cos(k*pi/(n+2)))/2;

end

B = transmatrix(domain.ang.phi,domain.ang.the,0);

wlength = 2000;
wlength2 = domain.vel(1)*domain.dt;
YS = test-span/2;
domain.WW{1} = [wlength2+XP(n+1) YS(1) ZP(n+1)];
XP = test2-domain.dt*domain.k*domain.vel(1);

xp = repmat(XP',1,m+1);
zp = repmat(ZP,1,m+1);
ys = repmat(YS,n+1,1);

x = [ones(1,m+1).*XP(n+1); ones(1,m+1).*(XP(n+1)+wlength2)];
y = [YS; YS];
z = [ones(1,m+1).*ZP(n+1); ones(1,m+1).*ZP(n+1)];

x2 = [ones(1,m+1).*XP(n+1); ones(1,m+1).*wlength];
y2 = [YS; YS];
z2 = [ones(1,m+1).*ZP(n+1); ones(1,m+1).*ZP(n+1)];

for j = 1:m
    
    for k = 1:n
        
        if (j == m && k == n)
            
          P = [XP(k) YS(j) ZP(k); XP(k) YS(j+1) ZP(k);...
          XP(k+1) YS(j+1) ZP(k+1); XP(k+1) YS(j) ZP(k+1)];
           
          WW = [XP(k+1) YS(j) ZP(k+1); XP(k+1) YS(j+1) ZP(k+1);...
          wlength YS(j+1) ZP(k+1); wlength YS(j) ZP(k+1)];
      
        elseif j == m
            
          P = [XP(k) YS(j) ZP(k); XP(k) YS(j+1) ZP(k);...
          XP(k+1) YS(j+1) ZP(k+1); XP(k+1) YS(j) ZP(k+1)];
      
        elseif k == n
            
          P = [XP(k) YS(j) ZP(k); XP(k) YS(j+1) ZP(k);...
          XP(k+1) YS(j+1) ZP(k+1); XP(k+1) YS(j) ZP(k+1)];
      
        WW = [XP(k+1) YS(j) ZP(k+1); XP(k+1) YS(j+1) ZP(k+1);...
          wlength YS(j+1) ZP(k+1); wlength YS(j) ZP(k+1)];
           
      
        else
        
        P = [XP(k) YS(j) ZP(k); XP(k) YS(j+1) ZP(k);...
          XP(k+1) YS(j+1) ZP(k+1); XP(k+1) YS(j) ZP(k+1)];
      
        end
        
    [Px,Py,Pz] = rotgeom2(B,domain.pos,P(:,1),P(:,2),P(:,3),0,0,0);
    P = [Px Py Pz];
    
    PP = mean(P);
    domain.CP{k,j} = PP;
    domain.P{k,j} = P;
    [domain.N{k,j},S(k,j)] = normalvec(P);
    
    end
    domain.W{j} = WW;
end

[x2,y2,z2] = rotgeom2(B,domain.pos,x2,y2,z2,0,0,0);

[x,y,z] = rotgeom2(B,domain.pos,x,y,z,0,0,0);

[xp,ys,zp] = rotgeom2(B,domain.pos,xp,ys,zp,0,0,0);

domain.wake.x = x2;
domain.wake.y = y2;
domain.wake.z = z2;
domain.test.x = x;
domain.test.y = y;
domain.test.z = z;
domain.test2.x = xp;
domain.test2.y = ys;
domain.test2.z = zp;
domain.S = S;

end