function [N,S] = normalvec(P)
% This function determines the normal vector and surface area of each
% element
A = P(3,:)-P(1,:); B = P(2,:)-P(4,:);
% N2 = cross(A,B);
X = A(2)*B(3)-A(3)*B(2); Y = A(3)*B(1)-A(1)*B(3); Z = A(1)*B(2)-A(2)*B(1);

A2 = sqrt(X^2+Y^2+Z^2);

N = [X/A2; Y/A2; Z/A2];

E = P(2,:)-P(1,:); F = P(4,:)-P(1,:);

S11 = F(2)*B(3)-F(3)*B(2);
S12 = F(3)*B(1)-F(1)*B(3);
S13 = F(1)*B(2)-F(2)*B(1);
S21 = E(2)*B(3)-E(3)*B(2);
S22 = E(1)*B(3)-E(3)*B(1);
S23 = E(1)*B(2)-E(2)*B(1);

S = 0.5*(sqrt(S11^2+S12^2+S13^2)+sqrt(S21^2+S22^2+S23^2));

end