function [Force] = transforce(B,hydro,aero,wind,hull)

[dd,ff] = size(hydro.res);

for j = 1:ff
    
   force = hydro.res(j); 
   
   F = [-abs(force.D);...
            -force.Ly;...
            abs(force.Lz)];

   % Translating forces from space to body. 
   F = B*F;
   F(1) = -abs(F(1));
   if j == 1
       Ff = F;
   else
       Ff = [Ff F];
   end
   
end
% Driving and heeling force respectively.
Fax = aero.res.Ly*sind(wind.beta)-aero.res.D*cosd(wind.beta);
Fay = aero.res.Ly*cosd(wind.beta)+aero.res.D*sind(wind.beta);

Fs = [abs(Fax); abs(Fay); 0];
% Translating forces from space to body
Fs = B*Fs;
% Determining hull resistance
Fvx = 2*hull.area*aero.domain.rho*wind.Va^2;
Fv = [-Fvx*cosd(wind.beta) 0;...
    Fvx*sind(wind.beta) 0;...
    -(hull.mass-hull.crew)*9.81 -hull.crew*9.81];

Force.Ff = Ff;
Force.Fs = Fs;
Force.Fv = Fv;


end